-- 我的赛程
checkRequire("Lua_ChampionshipRolePanel");
checkRequire("Lua_ChampionshipRecordItem");
Lua_ChampionshipMySchedulePanel = class("Lua_ChampionshipMySchedulePanel", Lua_DisplayObject)
function Lua_ChampionshipMySchedulePanel:ctor(p)
	self:superCall("ctor", p, "ChampionshipMySchedulePanel_skin");
end

function Lua_ChampionshipMySchedulePanel:buildShowItem()
	self:superCall("buildShowItem");
	self:addLuaEvent("CHAMPIONSHIP_SCHEDULE_INFO", self, self.updateShowInfo);

	self.bg:SetDimensions(720, 1099 + self.adaptHeight);
	self.noneObject:SetActive(false);
	self.showObject:SetActive(false);
	self.btnGoto:addClickFuntion(self, self.onGotoClick);
	self.btnLayOut:addClickFuntion(self, self.onBtnLayOutClick);

	self:onRequestInfo();
end

function Lua_ChampionshipMySchedulePanel:dispose()
	self:stopTimer();
	DataCenter.preLoadData:removeBySign("Lua_HeroLineupWindow", self, self.onSceneShow);
	if self.rolePanel ~= nil then
		self.rolePanel:dispose();
		self.rolePanel = nil;
	end
	if self.recordList then
		self.recordList:dispose();
		self.recordList = nil;
	end
	self:superCall("dispose");
end

function Lua_ChampionshipMySchedulePanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
	self.bg:SetDimensions(720, 1099 + adaptHeight);
	if self.recordList then
		self.recordList:setContentRect(720, 680 + adaptHeight);
	end
end

function Lua_ChampionshipMySchedulePanel:onRequestInfo()
	Lua_ProxyManager.getProxy("Lua_ChampionshipProxy"):sScheduleInfo();
end

function Lua_ChampionshipMySchedulePanel:updateShowInfo()
	self:stopTimer();
	local data = DataCenter.championshipData;
	local bValue = (data.isEnter ~= 2);
	if DataCenter.roleData:checkInTime(data.startTick, data.endTick) then
		self.timeIcon:setEnable(false);
		self.timeBg:setEnable(false);
		self.timeText:setEnable(false);
		if bValue then
			Lua_MsgUtil.callFunc("CHAMPIONSHIP_WINBG", 1);
			self.noneObject:SetActive(false);
			self.showObject:SetActive(true);
			if data.isEnter == 1 then
				self:showTips(false);
				if self.rolePanel == nil then
					self.rolePanel = Lua_ChampionshipRolePanel.new(self.showObject);
					self.rolePanel:setRectAnchor(1);
					self.rolePanel:setLocation(0, -322, 0);
					self.rolePanel:setCallBack(self, self.onRequestInfo);
				end
				self.rolePanel:setEnable(true);
				self.rolePanel:setRoleInfo(data.attRole, data.defRole, data.winPlayerId);
				self.rolePanel:setStageInfo(data.stageInfo, data.fightRecordId);
			else
				self:showTips(true);
				if self.rolePanel then
					self.rolePanel:setEnable(false);
				end
			end
		else
			Lua_MsgUtil.callFunc("CHAMPIONSHIP_WINBG", 0);
			self:showTips(false);
			self.noneObject:SetActive(true);
			self.showObject:SetActive(false);
		end

		if data.matchRecordList == nil or #data.matchRecordList <= 0 then
			self:showRecordTips(true)
			if self.recordList then
				self.recordList:setEnable(false)
			end
		else
			self:showRecordTips(false)
			if self.recordList == nil then
				self.recordList = Lua_DragList.new(self.showObject, 720, 680 + self.adaptHeight, Lua_AxisDefine.Vertical);
				self.recordList:setLocation(0, -145, 0);
				self.recordList:setListCell(Lua_ChampionshipRecordItem, 720, 138, 1);
				self.recordList:setCellSpacing(0, 10);
			end
			self.recordList:setArrayData(data.matchRecordList)
			self.recordList.canDrag = not self.recordList.isTheEnd
		end
	else
		Lua_MsgUtil.callFunc("CHAMPIONSHIP_WINBG", 0);
		self:showTips(false);
		self.noneObject:SetActive(true);
		self.showObject:SetActive(false);

		if data.startTick - DataCenter.roleData.serverTime > 0 then
			self.timeIcon:setEnable(true);
			self.timeBg:setEnable(true);
			self.timeText:setEnable(true);
			self:startTimer();
			self:onTimer();
		else
			self.timeIcon:setEnable(false);
			self.timeBg:setEnable(false);
			self.timeText:setEnable(false);
		end
	end

	self.openText.text = LanUtil.formateStr(540030, Lua_TimeTransform.transSeconds7(data.startTick));
	if DataCenter.funcOpenData:isOpened(10312) then
		self.condText:setLangValue(570094);
	else
		self.condText:setLangValue(540031);
	end
	if bValue then
		self.myRank.text = LanUtil.formateStr(570084, tostring(data.arenaRank));
	else
		self.myRank:setLangValue(570083);
	end
end

function Lua_ChampionshipMySchedulePanel:showTips(value)
	if value then
		if self.noneIcon == nil then
			self.noneIcon = UICreate.createImage(self.content, "/images/championship/xui_jys_widget_18.png", 14.5, -304, 0, 0);
			self.noneIcon.anchorValue = 1;

			self.noneText = UICreate.createLabel(self.content, nil, 7.5, -355, 100, 31, 32);
			self.noneText.anchorValue = 1;
			self.noneText.pivotValue = 4;
			self.noneText.fontName = Lua_MyUISettings.huakangFontName;
			self.noneText.alignmentValue = 4;
			self.noneText.horizontalOverflowValue = 1;
			self.noneText.verticalOverflowValue = 1;
			self.noneText.colorStr = Lua_ColorDefine.transColorStr("7A6C74");
			self.noneText:setLangValue(570085);
		end
		self.noneIcon:setEnable(true);
		self.noneText:setEnable(true);
	else
		if self.noneIcon then
			self.noneIcon:setEnable(false);
			self.noneText:setEnable(false);
		end
	end
end

function Lua_ChampionshipMySchedulePanel:showRecordTips(value)
	if value then
		if self.noTipsIcon == nil then
			self.noTipsIcon = UICreate.createImage(self.showObject, "/images/common/xui_common_widget_020.png", 0, -145, 0, 0);

			self.noTipsText = UICreate.createLabel(self.showObject, nil, 0, -210, 100, 31, 40);
			self.noTipsText.pivotValue = 4;
			self.noTipsText.fontName = Lua_MyUISettings.huakangFontName;
			self.noTipsText.alignmentValue = 4;
			self.noTipsText.horizontalOverflowValue = 1;
			self.noTipsText.verticalOverflowValue = 1;
			self.noTipsText.colorStr = Lua_ColorDefine.transColorStr("7A6C74");
			self.noTipsText:setLangValue(540043);
		end
		self.noTipsIcon:setEnable(true);
		self.noTipsText:setEnable(true);
	else
		if self.noTipsIcon then
			self.noTipsIcon:setEnable(false);
			self.noTipsText:setEnable(false);
		end
	end
end

function Lua_ChampionshipMySchedulePanel:startTimer()
	if self.bTiming ~= true then
		self.bTiming = true;
		self:addTimer("Lua_ChampionshipMySchedulePanel", 1, self, self.onTimer, nil, -1);
	end
end

function Lua_ChampionshipMySchedulePanel:stopTimer()
	if self.bTiming == true then
		self.bTiming = false;
		self:removeTimer(self, self.onTimer);
	end
end

function Lua_ChampionshipMySchedulePanel:onTimer()
	local second = DataCenter.championshipData.startTick - DataCenter.roleData.serverTime;
	if second > 0 then
		self.timeText.text = Lua_TimeTransform.transSeconds18(second, true, true, true, true);
	else
		self:stopTimer();
		self.timeIcon:setEnable(false);
		self.timeBg:setEnable(false);
		self.timeText:setEnable(false);
		self:onRequestInfo();
	end
end

function Lua_ChampionshipMySchedulePanel:onGotoClick(go)
	DataCenter.funcPathUtil:gotoFunction(1013, true);
end

function Lua_ChampionshipMySchedulePanel:onBtnLayOutClick(go)
	local sceneId = DataCenter.heroLineupData:getFightLineupSceneId(Lua_FightDefine.TEMPLATE_ID_CHAMPIONSHIP);
	DataCenter.preLoadData:preShowScene("Lua_HeroLineupWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onSceneShow, nil, sceneId, 0);
end

function Lua_ChampionshipMySchedulePanel:onSceneShow(param, mp, success)
	if not success then return; end
	Lua_WindowUtil.openWin("Lua_HeroLineupWindow", Lua_WinParam.ACTION_OPEN, Lua_HeroUtil.LINEUP_CHAMPIONSHIP);
end